=== unittest/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
add_subdirectory(src)
